other distros move to nodemanager that has a single specfile for all packages
[build.git] / lbuild-nightly.sh
1 #!/bin/bash
2
3 COMMANDPATH=$0
4 COMMAND=$(basename $0)
5
6 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
7 0<&-
8
9 # old guests have e.g. mount in /bin but this is no longer part of 
10 # the standard PATH in recent hosts after usrmove, so let's keep it simple
11 export PATH=$PATH:/bin:/sbin
12
13 # default values, tunable with command-line options
14 DEFAULT_FCDISTRO=f20
15 DEFAULT_PLDISTRO=lxc
16 DEFAULT_PERSONALITY=linux64
17 DEFAULT_MAILDEST="build at onelab.eu"
18 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
19 DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
20
21 # default gpg path used in signing yum repo
22 DEFAULT_GPGPATH="/etc/planetlab"
23 # default email to use in gpg secring
24 DEFAULT_GPGUID="root@$( /bin/hostname )"
25
26 DEFAULT_TESTCONFIG="default"
27 # for passing args to run_log
28 RUN_LOG_EXTRAS=""
29
30 # for publishing results, and the tests settings
31 DEFAULT_WEBPATH="/build/@PLDISTRO@/"
32 DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
33 # this is where the buildurl is pointing towards
34 DEFAULT_WEBROOT="/build/"
35 DEFAULT_TESTMASTER="testmaster.onelab.eu"
36
37 ####################
38 # assuming vm runs in UTC
39 DATE=$(date +'%Y.%m.%d')
40 BUILD_BEG=$(date +'%H:%M')
41 BUILD_BEG_S=$(date +'%s')
42
43 # still using /vservers for legacy reasons
44 # as far as the build & test infra, we could adopt a new name
45 # but the PL code still uses this name for now, so let's keep it simple
46 function rootdir () {
47     slice=$1; shift
48     echo /vservers/$slice
49 }
50 function logfile () {
51     slice=$1; shift
52     echo /vservers/$slice.log.txt
53 }
54
55 # wrap a quick summary of suspicious stuff
56 # this is to focus on installation that go wrong
57 # use with care, a *lot* of other things can go bad as well
58 function summary () {
59     from=$1; shift
60     echo "******************** BEG SUMMARY" 
61     python - $from <<EOF
62 #!/usr/bin/env python
63 # read a full log and tries to extract the interesting stuff
64
65 import sys,re
66 m_show_line=re.compile(".* (BEG|END) (RPM|LXC).*|.*'boot'.*|\* .*| \* .*|.*is not installed.*|.*PROPFIND.*|.* (BEG|END).*:run_log.*|.* Within LXC (BEG|END) .*|.* MAIN (BEG|END).*")
67 m_installing_any=re.compile('\r  (Installing:[^\]]*]) ')
68 m_installing_err=re.compile('\r  (Installing:[^\]]*])(..+)')
69 m_installing_end=re.compile('Installed:.*')
70 m_installing_doc1=re.compile("(.*)install-info: No such file or directory for /usr/share/info/\S+(.*)")
71 m_installing_doc2=re.compile("(.*)grep: /usr/share/info/dir: No such file or directory(.*)")
72
73 def summary (filename):
74
75     try:
76         if filename=="-":
77             filename="stdin"
78             f=sys.stdin
79         else:
80             f=open(filename)
81         echo=False
82         for line in f.xreadlines():
83             # first off : discard warnings related to doc
84             if m_installing_doc1.match(line):
85                 (begin,end)=m_installing_doc1.match(line).groups()
86                 line=begin+end
87             if m_installing_doc2.match(line):
88                 (begin,end)=m_installing_doc2.match(line).groups()
89                 line=begin+end
90             # unconditionnally show these lines
91             if m_show_line.match(line):
92                 print '>>>',line,
93             # an 'installing' line with messages afterwards : needs to be echoed
94             elif m_installing_err.match(line):
95                 (installing,error)=m_installing_err.match(line).groups()
96                 print '>>>',installing
97                 print '>>>',error
98                 echo=True
99             # closing an 'installing' section
100             elif m_installing_end.match(line):
101                 echo=False
102             # any 'installing' line
103             elif m_installing_any.match(line):
104                 if echo: 
105                     installing=m_installing_any.match(line).group(1)
106                     print '>>>',installing
107                 echo=False
108             # print lines when echo is true
109             else:
110                 if echo: print '>>>',line,
111         f.close()
112     except:
113         print 'Failed to analyze',filename
114
115 for arg in sys.argv[1:]:
116     summary(arg)
117 EOF
118     echo "******************** END SUMMARY" 
119 }
120
121 ### we might build on a box other than the actual web server
122 # utilities for handling the pushed material (rpms, logfiles, ...)
123 function webpublish_misses_dir () { ssh root@${WEBHOST}  "bash -c \"test \! -d $1\"" ; }
124 function webpublish () { ssh root@${WEBHOST} "$@" ; }
125 function webpublish_cp_local_to_remote () { scp $1 root@${WEBHOST}:$2 ; }
126 function webpublish_cp_stdin_to_file () { ssh root@${WEBHOST} cat \> $1; }
127 function webpublish_append_stdin_to_file () { ssh root@${WEBHOST} cat \>\> $1; }
128 # provide remote dir as first argument, so any number of local files can be passed next
129 function webpublish_rsync_dir () { rsync --archive --delete $VERBOSE $2 root@${WEBHOST}:$1 ; }
130 function webpublish_rsync_files () {
131     remote="$1"; shift
132     rsync --archive $VERBOSE "$@" root@${WEBHOST}:"$remote" ;
133 }
134
135 function pretty_duration () {
136     total_seconds=$1; shift
137
138     seconds=$(($total_seconds%60))
139     total_minutes=$(($total_seconds/60))
140     minutes=$(($total_minutes%60))
141     hours=$(($total_minutes/60))
142     
143     printf "%02d:%02d:%02d" $hours $minutes $seconds
144 }
145
146 # Notify recipient of failure or success, manage various stamps 
147 function failure() {
148     set -x
149     # early stage ? - let's not create /build/@PLDISTRO@
150     if  [ -z "$WEBLOG" ] ; then
151         WEBHOST=localhost
152         WEBPATH=/tmp
153         WEBBASE=/tmp/lbuild-early-$(date +%Y-%m-%d)
154         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
155     fi
156     webpublish mkdir -p $WEBBASE ||:
157     webpublish_cp_local_to_remote $LOG $WEBLOG ||:
158     summary $LOG | webpublish_append_stdin_to_file $WEBLOG ||:
159     (echo -n "============================== $COMMAND: failure at " ; date ; \
160         webpublish tail --lines=1000 $WEBLOG) | \
161         webpublish_cp_stdin_to_file $WEBBASE.ko ||:
162     if [ -n "$MAILDEST" ] ; then
163         ( \
164             echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
165             echo "To: $MAILDEST" ; \
166             echo "see build results at        $WEBBASE_URL" ; \
167             echo "including full build log at $WEBBASE_URL/log.txt" ; \
168             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
169             echo "........................................" ; \
170             webpublish tail --lines=1000 $WEBLOG ) | \
171             sendmail $MAILDEST
172     fi
173     exit 1
174 }
175
176 function success () {
177     set -x
178     # early stage ? - let's not create /build/@PLDISTRO@
179     if [ -z "$WEBLOG" ] ; then
180         WEBHOST=localhost
181         WEBPATH=/tmp
182         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
183     fi
184     webpublish mkdir -p $WEBBASE
185     webpublish_cp_local_to_remote $LOG $WEBLOG
186     summary $LOG | webpublish_append_stdin_to_file $WEBLOG
187     if [ -n "$DO_TEST" ] ; then
188         short_message="PASS"
189         ext="pass"
190         if [ -n "$IGNORED" ] ; then short_message="PASS/WARN"; ext="warn"; fi
191         ( \
192             echo "Successfully built and tested" ; \
193             echo "see build results at        $WEBBASE_URL" ; \
194             echo "including full build log at $WEBBASE_URL/log.txt" ; \
195             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
196             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
197             ) | webpublish_cp_stdin_to_file $WEBBASE.$ext
198         webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
199     else
200         short_message="PKGOK"
201         ( \
202             echo "Successful package-only build, no test requested" ; \
203             echo "see build results at        $WEBBASE_URL" ; \
204             echo "including full build log at $WEBBASE_URL/log.txt" ; \
205             ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
206         webpublish rm -f $WEBBASE.ko
207     fi
208     BUILD_END=$(date +'%H:%M')
209     BUILD_END_S=$(date +'%s')
210     if [ -n "$MAILDEST" ] ; then
211         ( \
212             echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
213             echo "To: $MAILDEST" ; \
214             echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
215             echo "see build results at        $WEBBASE_URL" ; \
216             echo "including full build log at $WEBBASE_URL/log.txt" ; \
217             [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
218             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
219             echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(pretty_duration $(($BUILD_END_S-$BUILD_BEG_S)))" ; \
220             ) | sendmail $MAILDEST
221     fi
222     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
223     # doesn't fix the problem, I'll remove it -- Sapan.
224     sleep 5
225     exit 0
226 }
227
228 ##############################
229 # manage root / container contexts
230 function in_root_context () {
231     rpm -q libvirt > /dev/null 
232 }
233
234 # run in the vm - do not manage success/failure, will be done from the root ctx
235 function build () {
236     set -x
237     set -e
238
239     echo -n "============================== Starting $COMMAND:build on "
240     date
241
242     cd /build
243     show_env
244     
245     echo "Running make IN $(pwd)"
246     
247     # stuff our own variable settings
248     MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
249     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
250     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
251     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
252     MAKEVARS=("MAILDEST=${MAILDEST}" "${MAKEVARS[@]}")
253     MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
254     MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
255     MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
256
257     MAKEVARS=("BASE=${BASE}" "${MAKEVARS[@]}")
258
259     # initialize latex
260     /build/latex-first-run.sh || :
261
262     # stage1
263     make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true 
264     # versions
265     make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
266     # actual stuff
267     make -C /build $DRY_RUN "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
268
269 }
270
271 # this was formerly run in the myplc-devel chroot but now is run in the root context,
272 # this is so that the .ssh config gets done manually, and once and for all
273 function run_log () {
274     set -x
275     set -e
276     trap failure ERR INT
277
278     echo "============================== BEG $COMMAND:run_log on $(date)"
279
280     ### the URL to the RPMS/<arch> location
281     # f12 now has everything in i686; try i386 first as older fedoras have both
282     url=""
283     for a in i386 i686 x86_64; do
284         archdir=$(rootdir $BASE)/build/RPMS/$a
285         if [ -d $archdir ] ; then
286             # where was that installed
287             url=$(echo $archdir | sed -e "s,$(rootdir $BASE)/build,${WEBPATH}/${BASE},")
288             url=$(echo $url | sed -e "s,${WEBROOT},${TESTBUILDURL},")
289             break
290         fi
291     done
292
293     if [ -z "$url" ] ; then
294         echo "$COMMAND: Cannot locate arch URL for testing"
295         failure
296         exit 1
297     fi
298
299     testmaster_ssh="root@${TESTMASTER}"
300
301     # test directory name on test box
302     testdir=${BASE}
303
304     # clean it
305     ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
306
307     # check it out in the build
308     virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "make -C /build tests-module"
309     
310     # push it onto the testmaster - just the 'system' subdir is enough
311     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
312     # toss the build in the bargain, so the tests don't need to mess with extracting it
313     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/build ${testmaster_ssh}:${BASE}/
314
315     # invoke test on testbox - pass url and build url - so the tests can use lbuild-initvm.sh
316     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
317
318     # temporarily turn off set -e
319     set +e
320     trap - ERR INT
321     ssh 2>&1 ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
322
323     set -e
324     trap failure ERR INT
325     # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
326     echo "retcod from run_log" $retcod
327     case $retcod in
328         0) success=true; IGNORED="" ;;
329         2) success=true; IGNORED=true ;;
330         *) success="";   IGNORED="" ;; 
331     esac
332
333     # gather logs in the build vm
334     mkdir -p $(rootdir $BASE)/build/testlogs
335     rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ $(rootdir $BASE)/build/testlogs
336     # push them to the build web
337     chmod -R a+r $(rootdir $BASE)/build/testlogs/
338     webpublish_rsync_dir $WEBPATH/$BASE/testlogs/ $(rootdir $BASE)/build/testlogs/
339
340     echo  "============================== END $COMMAND:run_log on $(date)"
341
342     if [ -z "$success" ] ; then
343         echo "Tests have failed - bailing out"
344         failure
345     fi
346     
347 }
348
349 # this part won't work if WEBHOST does not match the local host
350 # would need to be made webpublish_* compliant
351 # but do we really need this feature anyway ?
352 function sign_node_packages () {
353
354     echo "Signing node packages"
355     
356     need_createrepo=""
357
358     repository=$WEBPATH/$BASE/RPMS/
359     # the rpms that need signing
360     new_rpms=
361     # and the corresponding stamps
362     new_stamps=
363
364     for package in $(find $repository/ -name '*.rpm') ; do
365         stamp=$repository/signed-stamps/$(basename $package).signed
366         # If package is newer than signature stamp
367         if [ $package -nt $stamp ] ; then
368             new_rpms="$new_rpms $package"
369             new_stamps="$new_stamps $stamp"
370         fi
371         # Or than createrepo database
372         [ $package -nt $repository/repodata/repomd.xml ] && need_createrepo=true
373     done
374
375     if [ -n "$new_rpms" ] ; then
376         # Create a stamp once the package gets signed
377         mkdir $repository/signed-stamps 2> /dev/null
378         
379         # Sign RPMS. setsid detaches rpm from the terminal,
380         # allowing the (hopefully blank) GPG password to be
381         # entered from stdin instead of /dev/tty.
382         echo | setsid rpm \
383             --define "_signature gpg" \
384             --define "_gpg_path $GPGPATH" \
385             --define "_gpg_name $GPGUID" \
386             --resign $new_rpms && touch $new_stamps
387     fi
388
389      # Update repository index / yum metadata. 
390     if [ -n "$need_createrepo" ] ; then
391         echo "Indexing node packages after signing"
392         if [ -f $repository/yumgroups.xml ] ; then
393             createrepo --quiet -g yumgroups.xml $repository
394         else
395             createrepo --quiet $repository
396         fi
397     fi
398 }
399
400 function show_env () {
401     set +x
402     echo FCDISTRO=$FCDISTRO
403     echo PLDISTRO=$PLDISTRO
404     echo PERSONALITY=$PERSONALITY
405     echo BASE=$BASE
406     echo BUILD_SCM_URL=$BUILD_SCM_URL
407     echo MAKEVARS="${MAKEVARS[@]}"
408     echo DRY_RUN="$DRY_RUN"
409     echo PLDISTROTAGS="$PLDISTROTAGS"
410     # this does not help, it's not yet set when we run show_env
411     #echo WEBPATH="$WEBPATH"
412     echo TESTBUILDURL="$TESTBUILDURL"
413     echo WEBHOST="$WEBHOST"
414     if in_root_context ; then
415         echo PLDISTROTAGS="$PLDISTROTAGS"
416     else
417         if [ -f /build/$PLDISTROTAGS ] ; then
418             echo "XXXXXXXXXXXXXXXXXXXX Contents of tags definition file /build/$PLDISTROTAGS"
419             cat /build/$PLDISTROTAGS
420             echo "XXXXXXXXXXXXXXXXXXXX end tags definition"
421         else
422             echo "XXXXXXXXXXXXXXXXXXXX Cannot find tags definition file /build/$PLDISTROTAGS, assuming remote pldistro"
423         fi
424     fi
425     set -x
426 }
427
428 function setupssh () {
429     base=$1; shift
430     sshkey=$1; shift
431     
432     if [ -f ${sshkey} ] ; then
433         SSHDIR=$(rootdir ${base})/root/.ssh
434         mkdir -p ${SSHDIR}
435         cp $sshkey ${SSHDIR}/thekey
436         (echo "host *"; \
437             echo "  IdentityFile ~/.ssh/thekey"; \
438             echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
439         chmod 700 ${SSHDIR}
440         chmod 400 ${SSHDIR}/*
441     else 
442         echo "WARNING : could not find provided ssh key $sshkey - ignored"
443     fi
444 }
445
446 function usage () {
447     echo "Usage: $COMMAND [option] [var=value...] make-targets"
448     echo "Supported options"
449     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
450     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
451     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
452     echo " -m mailto - defaults to $DEFAULT_MAILDEST"
453     echo " -s build_scm_url - git URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
454     echo "    define GIT tag or branch name appending @tagname to url"
455     echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
456     echo " -b base - defaults to $DEFAULT_BASE"
457     echo "    @NAME@ replaced as appropriate"
458     echo " -o base: (overwrite) do not re-create vm, re-use base instead"
459     echo "    the -f/-d/-p/-m/-s/-t options are uneffective in this case"
460     echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
461     echo " -y {pl,pg} - passed to run_log"
462     echo " -e step - passed to run_log"
463     echo " -i step - passed to run_log"
464     echo " -X : passes --lxc to run_log"
465     echo " -S : passes --vs to run_log"
466     echo " -x <run_log_args> - a hook to pass other arguments to run_log"
467     echo " -w webpath - defaults to $DEFAULT_WEBPATH"
468     echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL; this is also used to get the hostname where to publish builds"
469     echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
470     echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
471     echo " -Y - sign yum repo in webpath"
472     echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
473     echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
474     echo " -K sshkey - specify ssh key to use when reaching git over ssh"
475     echo " -S - do not publish source rpms"
476     echo " -B - run build only"
477     echo " -T - run test only"
478     echo " -n - dry-run: -n passed to make - vm gets created though - no mail sent"
479     echo " -v - be verbose"
480     echo " -7 - uses weekday-@FCDISTRO@ as base"
481     echo " --build-branch branch - build using the branch from build module"
482     exit 1
483 }
484
485 function main () {
486
487     set -e
488     trap failure ERR INT
489
490     # parse arguments
491     MAKEVARS=()
492     MAKETARGETS=()
493     DRY_RUN=
494     DO_BUILD=true
495     DO_TEST=true
496     PUBLISH_SRPMS=true
497     SSH_KEY=""
498     SIGNYUMREPO=""
499
500     OPTS_ORIG=$@
501     OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:i:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
502     if [ $? != 0 ]
503     then
504         usage
505     fi
506     eval set -- "$OPTS"
507     while true; do
508         case $1 in
509             -f) FCDISTRO=$2; shift 2 ;;
510             -d) PLDISTRO=$2; shift 2 ;;
511             -p) PERSONALITY=$2; shift 2 ;;
512             -m) MAILDEST=$2; shift 2 ;;
513             -s) BUILD_SCM_URL=$2; shift 2 ;;
514             -t) PLDISTROTAGS=$2; shift 2 ;;
515             -b) BASE=$2; shift 2 ;;
516             -o) OVERBASE=$2; shift 2 ;;
517             -c) TESTCONFIG="$TESTCONFIG $2"; shift 2 ;;
518             ########## passing stuff to run_log
519             # -y foo -> run_log -y foo
520             -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --rspec-style $2"; shift 2 ;;
521             # -e foo -> run_log -e foo
522             -e) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --exclude $2"; shift 2 ;;
523             -i) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --ignore $2"; shift 2 ;;
524             # -X -> run_log --lxc
525             -X) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --lxc"; shift;;
526             # -S -> run_log --vs
527             -S) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --vs"; shift;;
528             # more general form to pass args to run_log
529             # -x foo -> run_log foo
530             -x) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS $2"; shift 2;;
531             ##########
532             -w) WEBPATH=$2; shift 2 ;;
533             -W) TESTBUILDURL=$2; shift 2 ;;
534             -r) WEBROOT=$2; shift 2 ;;
535             -M) TESTMASTER=$2; shift 2 ;;
536             -Y) SIGNYUMREPO=true; shift ;;
537             -g) GPGPATH=$2; shift 2 ;;
538             -u) GPGUID=$2; shift 2 ;;
539             -K) SSH_KEY=$2; shift 2 ;;
540             -S) PUBLISH_SRPMS="" ; shift ;;
541             -B) DO_TEST= ; shift ;;
542             -T) DO_BUILD= ; shift;;
543             -n) DRY_RUN="-n" ; shift ;;
544             -v) set -x ; VERBOSE="-v" ; shift ;;
545             -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
546             -P) PREINSTALLED="-P $2"; shift 2;;
547             -h) usage ; shift ;;
548             --) shift; break ;;
549         esac
550     done
551
552     # preserve options for passing them again later, together with expanded base
553     options=$OPTS_ORIG
554
555     # allow var=value stuff; 
556     for target in "$@" ; do
557         # check if contains '='
558         target1=$(echo $target | sed -e s,=,,)
559         if [ "$target" = "$target1" ] ; then
560             MAKETARGETS=(${MAKETARGETS[@]} "$target")
561         else
562             MAKEVARS=(${MAKEVARS[@]} "$target")
563         fi
564     done
565     
566     # set defaults
567     [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
568     [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
569     [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
570     [ -z "$MAILDEST" ] && MAILDEST=$(echo $DEFAULT_MAILDEST | sed -e 's, at ,@,')
571     [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
572     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
573     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
574     [ -z "$TESTBUILDURL" ] && TESTBUILDURL="$DEFAULT_TESTBUILDURL"
575     [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
576     [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
577     [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
578     [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
579     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
580     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
581
582     [ -n "$DRY_RUN" ] && MAILDEST=""
583
584     # elaborate the extra args to be passed to run_log
585     for config in ${TESTCONFIG} ; do
586         RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
587     done
588     
589         
590     if [ -n "$OVERBASE" ] ; then
591         sedargs="-e s,@DATE@,${DATE},g"
592         BASE=$(echo ${OVERBASE} | sed $sedargs)
593     else
594         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
595         BASE=$(echo ${BASE} | sed $sedargs)
596     fi
597
598     ### elaborate mail subject
599     if [ -n "$DO_BUILD" -a -n "$DO_TEST" ] ; then
600         MAIL_SUBJECT="full"
601     elif [ -n "$DO_BUILD" ] ; then
602         MAIL_SUBJECT="pkg-only"
603     elif [ -n "$DO_TEST" ] ; then
604         MAIL_SUBJECT="test-only"
605     fi
606     if [ -n "$OVERBASE" ] ; then
607         MAIL_SUBJECT="${MAIL_SUBJECT} rerun"
608     else
609         MAIL_SUBJECT="${MAIL_SUBJECT} fresh"
610     fi
611     short_hostname=$(hostname | cut -d. -f1)
612     MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
613
614     ### compute WEBHOST from TESTBUILDURL 
615     # this is to avoid having to change the builds configs everywhere
616     # simplistic way to extract hostname from a URL
617     WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
618
619     if ! in_root_context ; then
620         # in the vm
621         echo "==================== Within LXC BEG $(date)"
622         build
623         echo "==================== Within LXC END $(date)"
624
625     else
626         trap failure ERR INT
627         # we run in the root context : 
628         # (*) create or check for the vm to use
629         # (*) copy this command in the vm
630         # (*) invoke it
631         
632         if [ -n "$OVERBASE" ] ; then
633             ### Re-use a vm (finish an unfinished build..)
634             if [ ! -d $(rootdir ${BASE}) ] ; then
635                 echo $COMMAND : cannot find vm $BASE
636                 exit 1
637             fi
638             # manage LOG - beware it might be a symlink so nuke it first
639             LOG=$(logfile ${BASE})
640             rm -f $LOG
641             exec > $LOG 2>&1
642             set -x
643             echo "XXXXXXXXXX $COMMAND: using existing vm $BASE" $(date)
644             # start in case e.g. we just rebooted
645             virsh -c lxc:/// start ${BASE} || :
646             # retrieve environment from the previous run
647             FCDISTRO=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/getdistroname.sh)
648             BUILD_SCM_URL=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip +build-GITPATH")
649             # for efficiency, crop everything in one make run
650             tmp=/tmp/${BASE}-env.sh
651             virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip \
652                 ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILDEST ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
653             . $tmp
654             rm -f $tmp
655             # update build
656             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
657             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "cd /build; git pull; make tests-clean"
658             # make sure we refresh the tests place in case it has changed
659             rm -f /build/MODULES/tests
660             options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
661             [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
662             [ -n "$MAILDEST" ] && options=(${options[@]} -m $MAILDEST)
663             [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
664             [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
665             [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
666             show_env
667         else
668             # create vm: check it does not exist yet
669             i=
670             while [ -d $(rootdir ${BASE})${i} ] ; do
671                 # we name subsequent builds <base>-n<i> so the logs and builds get sorted properly
672                 [ -z ${i} ] && BASE=${BASE}-n
673                 i=$((${i}+1))
674                 if [ $i -gt 100 ] ; then
675                     echo "$COMMAND: Failed to create build vm $(rootdir ${BASE})${i}"
676                     exit 1
677                 fi
678             done
679             BASE=${BASE}${i}
680             # need update
681             # manage LOG - beware it might be a symlink so nuke it first
682             LOG=$(logfile ${BASE})
683             rm -f $LOG
684             exec > $LOG 2>&1 
685             set -x
686             echo "XXXXXXXXXX $COMMAND: creating vm $BASE" $(date)
687             show_env
688
689             ### extract the whole build - much simpler
690             tmpdir=/tmp/$COMMAND-$$
691             GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
692             GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
693             GIT_TAG=${GIT_TAG:-master}
694             mkdir -p $tmpdir 
695             ( git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -) || \
696                 ( echo "==================== git archive FAILED, trying git clone instead" ; \
697                   git clone $GIT_REPO $tmpdir && cd $tmpdir && git checkout $GIT_TAG && rm -rf .git)
698
699             # Create lxc vm
700             cd $tmpdir
701             ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE} 
702             # cleanup
703             cd -
704             rm -rf $tmpdir
705             # Extract build again - in the vm
706             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
707             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
708         fi
709         echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
710
711         # The log inside the vm contains everything
712         LOG2=$(rootdir ${BASE})/log.txt
713         (echo "==================== BEG LXC Transcript of vm creation" ; \
714          cat $LOG ; \
715          echo "==================== END LXC Transcript of vm creation" ; \
716          echo "xxxxxxxxxx Messing with logs, symlinking $LOG2 to $LOG" ) >> $LOG2
717         ### not too nice : nuke the former log, symlink it to the new one
718         rm $LOG; ln -s $LOG2 $LOG
719         LOG=$LOG2
720         # redirect log again
721         exec >> $LOG 2>&1 
722
723         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
724         WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
725         webpublish mkdir -p ${WEBPATH}
726
727         # where to store the log for web access
728         WEBBASE=${WEBPATH}/${BASE}
729         WEBLOG=${WEBPATH}/${BASE}/log.txt
730         # compute the log URL - inserted in the mail messages for convenience
731         WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
732     
733         if [ -n "$DO_BUILD" ] ; then 
734
735             # invoke this command into the build directory of the vm
736             cp $COMMANDPATH $(rootdir ${BASE})/build/
737
738             # invoke this command in the vm for building (-T)
739             virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "chmod +x /build/$COMMAND"
740             virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
741         fi
742
743         # publish to the web so run_log can find them
744         set +e
745         trap - ERR INT
746         webpublish rm -rf $WEBPATH/$BASE 
747         # guess if we've been doing any debian-related build
748         if [ ! -f $(rootdir $BASE)/etc/debian_version  ] ; then
749             webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
750             webpublish_rsync_dir $WEBPATH/$BASE/RPMS/ $(rootdir $BASE)/build/RPMS/
751             [[ -n "$PUBLISH_SRPMS" ]] && webpublish_rsync_dir $WEBPATH/$BASE/SRPMS/ $(rootdir $BASE)/build/SRPMS/
752         else
753             # run scanpackages so we can use apt-get on this
754             # (not needed on fedora b/c this is done by the regular build already)
755             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
756             webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
757             webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb 
758             webpublish_rsync_files $WEBPATH/$BASE/ $(rootdir $BASE)/build/Packages.gz
759         fi
760         # publish myplc-release if this exists
761         release=$(rootdir $BASE)/build/myplc-release
762         [ -f $release ] && webpublish_rsync_files $WEBPATH/$BASE $release
763         set -e
764         trap failure ERR INT
765
766         # create yum repo and sign packages.
767         if [ -n "$SIGNYUMREPO" ] ; then
768             # this script does not yet support signing on a remote (webhost) repo
769             sign_here=$(hostname) ; sign_web=$(webpublish hostname)
770             if [ "$hostname" = "$sign_here" ] ; then
771                 sign_node_packages
772             else
773                 echo "$COMMAND does not support signing on a remote yum repo"
774                 echo "you might want to turn off the -y option, or run this on the web server box itself"
775                 exit 1
776             fi
777         fi
778
779         if [ -n "$DO_TEST" ] ; then 
780             run_log
781         fi
782
783         success 
784
785         echo "==================== MAIN END $(date)"    
786     fi
787
788 }
789
790 ##########
791 main "$@"